//////////////////////////////////////////////////////////////////////
//                              ExecModify                       
// Copyright 2014 Malcolm Stagg
// Modified Version 1.0: 06/05/2014
//
//////////////////////////////////////////////////////////////////////

/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this program.  If not, see
<http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include "inc/IProcessorOpcode.h"
#include "inc/Amd64Opcode.h"

const char cAmd64Return[] = { 0xC3 }; // ret   (assuming near return)

bool Amd64Opcode::GetOpcode(char * szFromCode, char * szToOpcode, int &cbToOpcode)
{
	// just return code for now

	if (strcmp(szFromCode, "return;") == 0)
	{
		if (cbToOpcode >= sizeof(cAmd64Return))
		{
			memcpy(szToOpcode, cAmd64Return, sizeof(cAmd64Return));
			cbToOpcode = sizeof(cAmd64Return);
			return true;
		}
	}

	return false;
}
